<?php  
if (!isset($_POST['password']) || !isset($_POST['emailto']) || !isset($_POST['emailfrom']) || !isset($_POST['message']) || !isset($_POST['subject'])) {  
    echo 'Please enter all fields!';  
    exit;  
}  

function mail_attachment ($from , $to, $bcc, $subject, $message, $attachment, $attachment_tmpfile) {
	$fileatt = $attachment_tmpfile; // Path to the file 
	$fileatt_type = "application/octet-stream"; // File Type 

	$info = pathinfo($attachment);
	$fileatt_name = $info['filename']. '.' . $info['extension'];

	$email_from = $from; // Who the email is from 
	$email_subject = $subject; // The Subject of the email 
	$email_txt = $message; // Message that the email has in it 
	$email_to = $to; // Who the email is to
	$email_bcc = $bcc;

	// carriage return type (we use a PHP end of line constant)
	$eol = PHP_EOL;

	$semi_rand = md5(time()); 
	$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";

	$file = fopen($fileatt,'rb'); 
	$data = fread($file,filesize($fileatt)); 
	fclose($file);
	$data = chunk_split(base64_encode($data)); 
	 
	$headers = "From: ".$email_from.$eol;
	if ($email_bcc != "") {
		$headers .= "Bcc: ".$email_bcc.$eol;
	}
	$headers .= "MIME-Version: 1.0".$eol. 
		"Content-Type: multipart/mixed; boundary=\"{$mime_boundary}\""; 

	$email_message .= "This is a multi-part message in MIME format.".$eol.$eol. 
		"--{$mime_boundary}".$eol. 
		"Content-Type:text/html; charset=\"iso-8859-1\"".$eol. 
		"Content-Transfer-Encoding: 7bit".$eol.$eol. 
		$email_txt.$eol.$eol; 
	
	$email_message .= "--{$mime_boundary}".$eol.
		"Content-Type: {$fileatt_type}; name=\"{$fileatt_name}\"".$eol. 
		"Content-Transfer-Encoding: base64".$eol.$eol.  
		$data.$eol.$eol. 
		"--{$mime_boundary}--".$eol; 

	$ok = mail($email_to, $email_subject, $email_message, $headers); 

	if(!$ok) {
		throw new RuntimeException('Sorry could not send message');
	} 
}
  
$emailfrom = htmlspecialchars($_POST['emailfrom']);  
$emailto = htmlspecialchars($_POST['emailto']);  
$message = htmlspecialchars($_POST['message']);  
$subject = htmlspecialchars($_POST['subject']);
$password = htmlspecialchars($_POST['password']);

try {
	if ($password != '<useyourownpassword>') {
		throw new RuntimeException('Enter a valid password.');
	}

	if (isset($_POST['name']) && ($_POST['name'] != "")) {
		$name = htmlspecialchars($_POST['name']);
	} else {
		$name = "";
	}

	if (isset($_POST['emailbcc']) && ($_POST['emailbcc'] != "")) {
		$emailbcc = htmlspecialchars($_POST['emailbcc']);
		if (!filter_var($emailbcc, FILTER_VALIDATE_EMAIL)) {
			throw new RuntimeException('Please enter a valid bcc email address');
		}
	} else {
		$emailbcc = "";
	}

	
	if ($emailfrom == "") {
		throw new RuntimeException('Enter a email from.');
	}
	if ($emailto == "") {
		throw new RuntimeException('Enter a email to.');
	}

	if (!filter_var($emailfrom, FILTER_VALIDATE_EMAIL)) {
		throw new RuntimeException('Please enter a valid from email address');
	}

	if (!filter_var($emailto, FILTER_VALIDATE_EMAIL)) {
		throw new RuntimeException('Please enter a valid to email address');
	}

	if ($name != "") {
		$emailfrom = $name.' <'.$emailfrom.'>';
	}

	// only when a file is uploaded, otherwise simply use mail
	if (isset($_FILES['upfile']['error']) && ($_FILES['upfile']['error'] != UPLOAD_ERR_NO_FILE)) {

		// Undefined | Multiple Files | $_FILES Corruption Attack
		// If this request falls under any of them, treat it invalid.
		if (!isset($_FILES['upfile']['error']) || is_array($_FILES['upfile']['error'])) {
			throw new RuntimeException('Invalid parameters.');
		}

		// Check $_FILES['upfile']['error'] value.
		switch ($_FILES['upfile']['error']) {
			case UPLOAD_ERR_OK:
				break;
			case UPLOAD_ERR_NO_FILE:
				throw new RuntimeException('No file sent.');
			case UPLOAD_ERR_INI_SIZE:
			case UPLOAD_ERR_FORM_SIZE:
				throw new RuntimeException('Exceeded filesize limit.');
			default:
				throw new RuntimeException('Unknown errors.');
		}

		// You should also check filesize here. 
		if ($_FILES['upfile']['size'] > 20000000) {
			throw new RuntimeException('Exceeded filesize limit.');
		}

		mail_attachment ($emailfrom, $emailto, $emailbcc, $subject, $message, $_FILES['upfile']['name'], $_FILES['upfile']['tmp_name']);
	} else {
		$eol = PHP_EOL;
		$headers = "From: ".$emailfrom.$eol;
		if ($emailbcc != "") {
			$headers .= "Bcc: ".$emailbcc.$eol;
		}
		if (!mail($emailto, $subject, $message, $headers)) {
			throw new RuntimeException('Error sending mail.');
		}
	}
	echo "OK";
} catch (RuntimeException $e) {
	echo $e->getMessage();
}
?>  
